﻿$EFT = New-Object -ComObject 'SFTPComInterface.CIServer'
$eftAdminUserName = 'admin'
$eftPassword = 'alaska'
$eftServer = '192.168.100.120'
$eftPort = '1100'
$EFT.Connect($eftServer, $eftPort, $eftAdminUserName, $eftPassword)

$Sites = $EFT.Sites()
$site = $Sites.SiteByID(1)

$sftpsettings = $site.GetSFTPAccess()
$sftpencoding = $site.SFTPEncoding     # 1 = UTF-8, 2 = ASCII
$sftpblob = $site.SFTPPublicKeyBlob
$algorithms = $site.SFTPEncodingAlgorithms
$identification = $site.SFTPIdentificationComment
$kexciphers = $site.SFTPKexAlgorithms
$macalgorithms = $site.SFTPMacAlgorithms
$port = $site.SFTPPort
$version = $site.SFTPSoftwareVersion
$algs = $algorithms.split(',')
$kex = $kexciphers.split(',')
$macs = $macalgorithms.split(',')
$sftpfipsenabled = $EFT.SSHFIPSEnabled
$sslfipsenabled = $EFT.SSLFIPSEnabled

Clear-Host

Write-Output "Is SFTP enabled on my site = $sftpsettings" `n
Write-Output "SFTP Encoding = $sftpencoding" `n
Write-Output "Public Key Blob `n $sftpblob" `n 
Write-Output "Allowed ciphers enabled on my SFTP site:"`n ($algs|Format-List) `n
Write-Output "Identification comment `n $identification" `n
Write-Output "Allowed KEX ciphers enabled on my SFTP site:" `n ($kex|Format-List) `n
Write-Output "Allowed MACs enabled on my SFTP site:"`n ($macs|Format-List) `n
Write-Output "SFTP port in use: `n`n $port" `n
Write-Output "SFTP Software Version: `n`n $version" `n
Write-Output "Is SFTP FIPS ENABLED: `n $sftpfipsenabled" `n
Write-Output "Is SSL FIPS ENABLED: `n $sslfipsenabled" `n


