﻿<# 
.SYNOPSIS 
    get or set a site's HTTPDomain
 
.DESCRIPTION 
    get or set a site's HTTPDomain

#>

param(
    [Parameter(Mandatory=$False)][string]$eftSiteName = "MySite",
    [Parameter(Mandatory=$False)][int]$eftAdminPort = 1100,
    [Parameter(Mandatory=$False)][string]$eftAdminName = "admin",
    [Parameter(Mandatory=$False)][string]$eftAdminPassword = "myAdmin123",
    [Parameter(Mandatory=$False)][string][string]$domain = ""
)


#------------------------------------------------------------
# login as admin
#------------------------------------------------------------

try {
    $server = New-Object -ComObject 'SFTPComInterface.CIServer'
    $server.Connect( "localhost", $eftAdminPort, $eftAdminName, $eftAdminPassword );
    Write-Host "connected"
}
catch {
    $errorMessage = $_.Exception.Message;
    Write-Host "failed to connect to server: $errorMessage"
    Exit;
}

#------------------------------------------------------------
# find the specified site
#------------------------------------------------------------

$sites = $server.Sites();
$site = $null
for( $i = 0; $i -lt $sites.Count(); $i++ ) {
   $site = $sites.Item($i); # TODO: find MySite from list
   if ($site.Name -eq $eftSiteName ) {
      Write-Host "site name is " $site.Name
      break;
   }
}

if( $site -eq $null ) {
   Write-Host "failed to find site $eftSiteName";
   Exit;
}


$server.RefreshSettings();


#------------------------------------------------------------
# set or get the domain
#------------------------------------------------------------

if($domain.Length -eq 0)
{
    Write-Output ("HTTP Domain is {0}" -f $site.HTTPDomain)
}
else
{
    $site.HTTPDomain = $domain
    $server.ApplyChanges()
}

