﻿<# Fetch the command line parameters:
QAComBasicScriptTLSVersions2.ps1 -HOSTADD "Host Address" -USER "User" -PASS "Password" -PORT "COM Port" -SSLV "TLSVersion" #>


param(
[string] $HostAdd,[String] $User,[String] $Pass,[String] $Port,[String] $SSLv
)


if ($HostAdd -eq '') {
   write-Host "Script exiting do to missing parameter Host address"
   write-Host "Script example: QAComBasicScriptTLSVersions2.ps1 host address User Password Port TLSVersion"
   exit 1
   }
ElseIf ($User -eq '') {
   write-Host "Script exiting do to missing parameter EFT username"
   write-Host "Script example: QAComBasicScriptTLSVersions2.ps1 host address User Password Port TLSVersion"
   exit 1
}
ElseIf ($Pass -eq '') {
   write-Host "Script exiting do to missing parameter User password"
   write-Host "Script example: QAComBasicScriptTLSVersions2.ps1 host address User Password Port TLSVersion"
   exit 1
} 
ElseIf ($Port -eq '') {
   write-Host "Script exiting do to missing parameter COM admin port"
   write-Host "Script example: QAComBasicScriptTLSVersions2.ps1 host address User Password Port TLSVersion"
   exit 1
}

$EFT = New-Object -ComObject 'SFTPComInterface.CIServer'

$EFT.Connect($HostAdd, $Port, $User, $Pass)

if ($SSLv -eq 'TLSv1' ) {
   $SSL = '1'
} ElseIf ($SSLv -eq 'TLSv11') {
   $SSL = '8'
} ElseIf ($SSLv -eq 'TLSv12') {
   $SSL = '15'
} Else {
   $SSL = '25'
}

$EFT.SSLVersionMask = $SSL

# write out the new TLS value.
Write-Host $EFT.SSLVersionMask

# stop and start the EFT Server Enterprise service so the TLS change is picked up.
$mycred = new-object -TypeName System.Management.Automation.PSCredential -argumentlist "Administrator", (Get-Content 'c:\securestring.txt' | convertto-securestring)
Enter-PSSession -ComputerName DY2012EFT3 -Credential $mycred 
net stop "EFT Server Enterprise"
net start "EFT Server Enterprise"
exit


