﻿$EFT = New-Object -ComObject 'SFTPComInterface.CIServer'
$eftUser = 'Admin'
$eftPassword = 'alaska'
$eftServer = '127.0.0.1'
$eftPort = '1100'
$EFT.Connect($eftServer, $eftPort, $eftUser, $eftPassword)

$Sites = $EFT.Sites()
$site = $Sites.SiteByID(1)

#This creates an Array with all the available pgp types so that they can be listed in the UI with the created typer
$keyTypeArray = New-Object System.Collections.ArrayList
$keyTypeArray.Add('DSS')
$keyTypeArray.Add('RSA')
$keyTypeArray.Add('RSA-Legacy')


#This creates an Array with all the available Ciphers so that they can be listed in the UI with the created cipher
$keyCipherArray = New-Object System.Collections.ArrayList
$keyCipherArray.Add('IDEA')> $null
$keyCipherArray.Add('3DES') > $null
$keyCipherArray.Add('CAST5')> $null
$keyCipherArray.Add('AES128')> $null
$keyCipherArray.Add('AES192')> $null
$keyCipherArray.Add('AES256')> $null
$keyCipherArray.Add('TWOFISH')> $null

For ($keyType = 0; $keyType -le 2; $keyType++)
{
    #This for loop runs through the 7 different OpenPGP Key Ciphers (3DES, AES128, AES192, AES256, CAST5, IDEA, TWOFISH)
    for ($keyCipher = 0; $keyCipher -le 6; $keyCipher++) 
    {
        $PGPKey1 = $site.CreatePGPKey("PGPKey: "+" "+$keyTypeArray[$keyType]+"_"+$keyCipherArray[$keyCipher],"ivasquez@globalscape.com", (Get-Date).AddYears(1),$keyType,$keyCipher,1024,"Pass12#")
        #When the following are all enabled this will take a long time to complete!
        #$PGPKey1 = $site.CreatePGPKey("IvanKey","ivasquez@globalscape.com", (Get-Date).AddYears(1),$keyType,$keyCipher,2048,"Pass12#")
        #$PGPKey1 = $site.CreatePGPKey("IvanKey","ivasquez@globalscape.com", (Get-Date).AddYears(1),$keyType,$keyCipher,3072,"Pass12#")
        #$PGPKey1 = $site.CreatePGPKey("IvanKey","ivasquez@globalscape.com", (Get-Date).AddYears(1),$keyType,$keyCipher,4096,"Pass12#")
    }
}
