﻿$EFT = New-Object -ComObject 'SFTPComInterface.CIServer'
$eftUser = 'Admin'
$eftPassword = 'alaska'
$eftServer = '127.0.0.1'
$eftPort = '1100'
$EFT.Connect($eftServer, $eftPort, $eftUser, $eftPassword)

$Sites = $EFT.Sites()
$site = $Sites.SiteByID(1)

New-Object -ComObject 'SFTPComInterface.CIServer' | Get-Member > CIServer.txt
New-Object -ComObject 'SFTPCOMInterface.CIEventRule' | Get-Member > CIEventRule.txt

$SubroutineName = 'TestSubroutine'
$TimerName = 'TestSubroutineTimer'

############################
# CREATE SUBROUTINE RULE
############################
$rulesSubroutine = $site.EventRules(0x9001) # SubRoutine Rule
$subroutineRuleParams = New-Object -ComObject 'SFTPComInterface.CIEventRuleParams'
$subroutineRuleParams.Name = $SubroutineName
$ruleSubroutine = $rulesSubroutine.Add(0, $subroutineRuleParams)

# ADD STOP ACTION
$stopActionparams = New-Object -ComObject 'SFTPComInterface.CIStopActionParams'
$ruleSubroutine.AddActionStatement($ruleSubroutine.StatementsCount(),$stopActionparams)

############################
# CREATE TIMER RULE
############################
$rulesTimer = $site.EventRules(0x1001) # Timer Rule
$timerRuleParams = New-Object -ComObject 'SFTPComInterface.CITimerEventRuleParams'
$timerRuleParams.Name = $TimerName
$ruleTimer = $rulesTimer.Add(0, $timerRuleParams)

# ADD SUBROUTINE ACTION
$callSubroutineActionparams = New-Object -ComObject 'SFTPComInterface.CICallSubroutineActionParams'
$callSubroutineActionparams.SubroutineName = $SubroutineName
$ruleTimer.AddActionStatement($ruleTimer.StatementsCount(),$callSubroutineActionparams)

# ADD MAIL ACTION
$mailActionparams = New-Object -ComObject 'SFTPComInterface.CIMailActionParams'
$mailActionparams.Body = 'Test'
$mailActionparams.Subject ='Yada'
$mailActionparams.TOAddresses = 'ivasquez@globalscape.com'
$ruleTimer.AddActionStatement($ruleTimer.StatementsCount(),$mailActionparams)
