Set SFTPServer = WScript.CreateObject("SFTPCOMInterface.CIServer")

   txtServer = "localhost"
   txtPort =  "1100"
   txtAdminUserName = "admin"
   txtAdminPassword = "Test1"
   txtSiteName = "MySite"


SFTPServer.Connect txtServer, txtPort, txtAdminUserName, txtAdminPassword

WScript.Echo "Connected to EFT Server: "  & txtServer

Set Sites=SFTPServer.Sites

'This loop will loop through the current sites on the server until it finds the one that matches the specified Site Name specified in "txtSiteName"
'Once the site name matches, it will perform the actions underneath
For i = 0 to SFTPServer.Sites.Count-1
   Set theSite=Sites.Item(i)
   if LCase(Trim(theSite.Name)) = LCase(Trim(txtSiteName)) then


	'The below lines (up until "to Next") perform the GetUsers() method that populates an array which is then listed.
	WScript.Echo ""
	WScript.Echo "Site User List Is: "

	Dim arSiteUsers : arSiteUsers = theSite.GetUsers()
	for t = LBound(arSiteUsers) to UBound(arSiteusers)
		WScript.Echo "********* - User    : " & CStr(t) & " - " & arSiteUsers(t)	
		WScript.Echo "********* - Outbound"

		Set oUserSettings = theSite.GetUserSettings(arSiteUsers(t))

		Set arAS2O = oUserSettings.AS2OutboundSettings

		WScript.Echo "Own AS2 ID    : " & arAS2O.AS2ID
		WScript.Echo "Partner AS2 ID: " & arAS2O.PartnerAS2ID
		Wscript.Echo "Custom Headers: " & arAS2O.CustomHeaders
		
		' SignatureAlgorithm
		' SHA1 = 0
		' MD5  = 1
		' SHA256 = 2
		' SHA384 = 3
		' SHA512 = 4
		currentSignature = arAS2O.SignatureAlgorithm
		on error resume next
		arAS2O.SignatureAlgorithm = "MySignature"
		If Err.Number <> 0 Then
			Wscript.Echo "Set Signature algorithm to text failed (expected to fail): " & Err.Description
			Err.Clear
		End If
		arAS2O.SignatureAlgorithm = 14
		If Err.Number <> 0 Then
			Wscript.Echo "Set Signature algorithm to 14 failed (expected to fail): " & Err.Description
			Err.Clear
		End If
		arAS2O.SignatureAlgorithm = 2
		Wscript.Echo "Signature Alg (expect 2): " & arAS2O.SignatureAlgorithm
		If Err.Number <> 0 Then
			Wscript.Echo "Set Signature algorithm to 3 failed: " & Err.Description
			Err.Clear
		End If
		arAS2O.CustomHeaders = "Myheader: sdf" & vbcrlf &_
					"path: temp" & vbcrlf &_
					"MyHeader: newheader"
		If Err.Number <> 0 Then
 			WScript.Echo "Error Source: " &  Err.Source
			WScript.Echo "Error Description: " &  Err.Description
			' Clear the Error
			Err.Clear
		End If
		' EncryptionAlgorithm
		' 3DES = 0
		' DES  = 1
		' AESCBC128 = 2
		' AESCBC192 = 3
		' AESCBC256 = 4
		currentEncryption = arAS2O.EncryptionAlgorithm
		Wscript.Echo "Encryption Alg: " & arAS2O.EncryptionAlgorithm
		arAS2O.EncryptionAlgorithm = 0
		If Err.Number <> 0 Then
			Wscript.Echo "Set Encryption algorithm to 0 failed: " & Err.Description
			Err.Clear
		End If		
		Wscript.Echo "Encryption Alg (expect unchanged): " & arAS2O.EncryptionAlgorithm
		arAS2O.EncryptionAlgorithm = 3
		If Err.Number <> 0 Then
			Wscript.Echo "Set Encryption algorithm to 3 failed: " & Err.Description
			Err.Clear
		End If		
		Wscript.Echo "Encryption Alg (expect 3): " & arAS2O.EncryptionAlgorithm

		arAS2O.EncryptionAlgorithm = currentEncryption
		Wscript.Echo "Encryption Alg: " & arAS2O.EncryptionAlgorithm
		Wscript.Echo "Signature Alg : " & arAS2O.SignatureAlgorithm
		arAS2O.SignatureAlgorithm = currentSignature
		Wscript.Echo "Signature Alg : " & arAS2O.SignatureAlgorithm
		'on error goto 0
		
		
		'****************************************************************************
		
		Wscript.Echo "********* - Inbound"
		Set arAS2I = oUserSettings.AS2InboundSettings
		If Err.Number <> 0 Then
			Wscript.Echo Err.Description
			Err.Clear
		End If
		WScript.Echo "Partner AS2 ID: " & arAS2I.PartnerAS2ID
		If Err.Number <> 0 Then
			Wscript.Echo Err.Description
			Err.Clear
		End If
		currentEncryption = arAS2I.EncryptionAlgorithm
		WScript.Echo "Encryption Alg: " & arAS2I.EncryptionAlgorithm
		arAS2I.EncryptionAlgorithm = "3DES, AESCBC192 , 3DES, AESCBC256 ,bubble"
		If Err.Number <> 0 Then
			Wscript.Echo "Change Encryption Algorithm to text failed: " & Err.Description
			Err.Clear
		End If
		arAS2I.EncryptionAlgorithm = "AESCBC256"
		If Err.Number <> 0 Then
			Wscript.Echo "Change Encryption Algorithm to AESCBC256 failed: " & Err.Description
			Err.Clear
		End If
		WScript.Echo "Encryption Alg (expect AESCBC256): " & arAS2I.EncryptionAlgorithm
		arAS2I.EncryptionAlgorithm = "3DES, AESCBC192 , AESCBC256, AESCBC128, 3DES, AESCBC256 ,bubble"
		If Err.Number <> 0 Then
			Wscript.Echo "Change Encryption Algorithm to 31 failed: " & Err.Description
			Err.Clear
		End If
		WScript.Echo "Encryption Alg (expect 'AESCBC128,...'): " & arAS2I.EncryptionAlgorithm
		arAS2I.EncryptionAlgorithm = currentEncryption
		currentSignature = arAS2I.SignatureAlgorithm
		WScript.Echo "Signature Alg : " & arAS2I.SignatureAlgorithm
		arAS2I.SignatureAlgorithm = 5
		If Err.Number <> 0 Then
			Wscript.Echo "Failed setting SignatureAlgorithm to 5: " & Err.Description
			Err.Clear
		End If
		WScript.Echo "Signature Alg (expect '') :" & arAS2I.SignatureAlgorithm
		arAS2I.SignatureAlgorithm = "SHA1  , MD5 ,  SHA-256  , SHA-384  , 3DES , SHA-256 , SHA-512 ,bubble"
		If Err.Number <> 0 Then
			Wscript.Echo "Failed setting SignatureAlgorithm to list: " & Err.Description
			Err.Clear
		End If
		WScript.Echo "Signature Alg (expect 'SHA1,MD5,SHA-256,SHA-384,SHA-512') :" & arAS2I.SignatureAlgorithm
		arAS2I.SignatureAlgorithm = 56
		If Err.Number <> 0 Then
			Wscript.Echo "Failed setting SignatureAlgorithm to 56: " & Err.Description
			Err.Clear
		End If
		WScript.Echo "Signature Alg : " & arAS2I.SignatureAlgorithm
		arAS2I.SignatureAlgorithm = currentSignature
		If Err.Number <> 0 Then
			Wscript.Echo Err.Description
			Err.Clear
		End If
		
		WScript.Echo "Signature Alg : " & arAS2I.SignatureAlgorithm
		Wscript.Echo "********* - end"
	Next


	
   end if
Next

SFTPServer.Close
Set SFTPServer = nothing