 'This will create all PGP key types, add them to event rules, and encrypt/decrypt a file, encrypt and sign/decrypt and verify, Sign/Verify a file


PGPKeyTypes = Array("PGPKeyType_DSS", "PGPKeyType_RSA", "PGPKeyType_RSALegacy")
PGPKeyCiphers = Array("PGPKeyCipher_3DES", "PGPKeyCipher_AES128", "PGPKeyCipher_AES192", "PGPKeyCipher_AES256", "PGPKeyCipher_CAST5", "PGPKeyCipher_IDEA", "PGPKeyCipher_TWOFISH")
PGPKeySizes = Array(1024, 2048, 3072, 4096)
const Decrypt = 4
const DecryptAndVerify = 5 
const Encrypt = 0 
const EncryptAndSign = 1
const SDA = 3
const Sign = 2
const VerifyOnly = 6
Const TotalCompressionValues = 9 ' this is for the different compression levels, although there are 9, zero means its disabled.
Const TotalHashValues = 5 'This is for the different hash values, there are currently 6 availble options however the list starts from zero
Dim CompressionValue, HashValue, KeyCount, mainLoopCount, EncryptLoop, EncryptAndSignLoop 



FileCheck                                               'make sure test file exists



Set SFTPServer = CreateObject("SFTPCOMInterface.CIServer")
SFTPServer.Connect "192.168.206.131",1100,"admin","p"
set Sites=SFTPServer.Sites
set site = Sites.Item(0)

WScript.Echo "Removing Previous PGPKeys... " 
RemovePGPKeys
CreatePGPKeys
WScript.Echo "Total Keys Created: " & vbTab	& KeyCount
HashValue = 0
CompressionValue = 0 'Values range from 0 - 9, where 0 is No compression
mainLoopCount =0
FolderPrep
ClearEventLog
EncryptLoop = False
WScript.echo "Initial HashValue:" & vbTab & ": " & HashValue
WScript.echo "Initial CompressionValue: " & vbTab & ": " & CompressionValue

'for each nested loops
For Each Key In SFTPServer.AvailablePGPKeys
	triggerflag = False
	guid = CreateGuid
	a=Split(Key.Name," <")
		Do 'Encrypt Loop
				WScript.Echo "Executing Encrypt and Decrypt Event Rules"
				WScript.Echo "-----------------------------------------"
				wscript.echo "checking:" & vbTab & Key.ID & ": " & a(0)
			'	WScript.Echo "KeyCount: " &KeyCount
				mainLoopCount = mainLoopCount + 1 'Keeps count of the loop to compare the number of runs
			'	WScript.Echo "mainLoopCount: " & mainLoopCount
				For ASCIIArmored = 0 To 1 '0 = False (Disabled) 1 = True (Enabled)
			  			While(CompressionValue <= TotalCompressionValues)
			  					AddEncryptRule Array(Key.ID), Encrypt, ASCIIArmored, CompressionValue  
								AddDecryptRule Array(Key.ID), Decrypt, guid
								WScript.sleep 1000
								wscript.echo vbTab & "seeding folder monitor with file..."
								Path = "c:\OpenPGP\pgpencrypt"
							    SeedCopy(Path)
							    wscript.sleep 1000
							    wscript.echo vbTab & "checking for event"
							    While (triggerflag = False)             'go into checking loop
							        Call CheckEventLog(guid)                
							        wscript.sleep 1000
							    Wend 
						   		WScript.echo "Current CompressionValue: " & vbTab & ": " & CompressionValue
						   		'**** We need to do a file comparison for the file located at c:\test.bin and c:\OpenPGP\pgpdecrypt\timestamp%test.bin****
				     		CompressionValue = CompressionValue +1 'Increase Compression Level
						Wend 'End loop for Compression Level
				CompressionValue = 0 'Reset Compression value for next key
			    If ASCIIArmored = 0 Then
						WScript.Echo "Continuing with next ASCII-Armored setting..."
			    ElseIf ASCIIArmored = 1 Then
						WScript.Echo "Continuing with next PGP Key..." 
						EncryptLoop = True
			    End If
			    Next 'Loop for ASCII-Armored
			  
			If mainLoopCount = KeyCount Then
			 	WScript.Echo "All PGP Keys completed..." 
				WScript.Echo "Continuing with Next Event Rule..."
				'WScript.Echo "***Current Count is now: " &mainLoopCount&" ***"
				
				mainLoopCount = 0
			
			End If
	        Path = Null
			Loop While EncryptLoop <> True 'Runs loop for EncryptandSign until its complete or True  

		mainLoopCount = 0

			Do 'Encrypt and Sign Loop
				WScript.Echo "Executing Encrypt and Sign followed by Decrypt and Verify Signature Event Rules"
				WScript.Echo "-------------------------------------------------------------------------------"
				wscript.echo "checking:" & vbTab & Key.ID & ": " & a(0)
			'	WScript.Echo "KeyCount: " &KeyCount
				mainLoopCount = mainLoopCount + 1 'Keeps count of the loop to compare the number of runs
			'	WScript.Echo "mainLoopCount: " & mainLoopCount
				For ASCIIArmored = 0 To 1 '0 = False (Disabled) 1 = True (Enabled)
					WScript.echo "Current HashValue:" & vbTab & ": " & HashValue
					WScript.echo "Current CompressionValue: " & vbTab & ": " & CompressionValue
				  	While(CompressionValue <= TotalCompressionValues) 
			    		While(HashValue <= TotalHashValues)
								AddEncryptAndSignRule Array(Key.ID), EncryptAndSign,CompressionValue, HashValue, ASCIIArmored	
								AddDecryptAndVerifyRule Array(Key.ID), DecryptAndVerify, guid
								WScript.sleep 1000
							    wscript.echo vbTab & "seeding folder monitor with file..."
							    Path = "c:\OpenPGP\pgpencryptandsign"
							    SeedCopy(Path)
	    						wscript.sleep 1000
							    wscript.echo vbTab & "checking for event"
							    While (triggerflag = False)             'go into checking loop
							        Call CheckEventLog(guid)                
						        wscript.sleep 1000
							    Wend
					    		HashValue = HashValue + 1
					    		If HashValue <= TotalHashValues Then
								'**** We need to do a file comparison for the file located at c:\test.bin and c:\OpenPGP\pgpdecryptandverify\timestamp%test.bin****
							   	End if	   	
					 	 Wend 'End Loop for HashValue
				     CompressionValue = CompressionValue +1 'Increase Compression Level
				     HashValue = 0 'Reset the HashValue back to zero for next key
					Wend 'End loop for Compression Level
				CompressionValue = 0 'Reset Compression value for next key
				WScript.Echo "Resetting Values: " & vbTab & "Hash Value: " & HashValue & " Compression Value: " & CompressionValue 
				If ASCIIArmored = 0 Then
							WScript.Echo "Continuing with next ASCII-Armored setting..."
					  ElseIf ASCIIArmored = 1 Then
							WScript.Echo "Continuing to next PGP Key..." 
							EncryptAndSignLoop = True
							
					  End If
			  Next 'Loop for ASCII-Armored  
			  
			  If mainLoopCount = KeyCount Then
					WScript.Echo "All PGP Keys completed..." 
					WScript.Echo "Continuing with Next Event Rule..."
					'WScript.Echo "***Current Count is now: " &mainLoopCount&" ***"
			 		mainLoopCount = 0
					 	  	
			  End If
			  Path = Null
			  Loop While EncryptAndSignLoop <> True
			  
			mainLoopCount = 0 
			Outputfile = 0
			ASCIIArmored = 0
			HashValue = 0
	
				Do 'Sign Only Loop
				WScript.Echo "Executing Sign Only followed by Verify Signature Only Event Rules"
				WScript.Echo "-----------------------------------------------------------------"
				wscript.echo "checking:" & vbTab & Key.ID & ": " & a(0)
				'WScript.Echo "KeyCount: " &KeyCount
				mainLoopCount = mainLoopCount + 1 'Keeps count of the loop to compare the number of runs
				'WScript.Echo "mainLoopCount: " & mainLoopCount
				For ASCIIArmored = 0 To 1 '0 = False (Disabled) 1 = True (Enabled)				
					For OutputFile = 0 To 1 '0 = Target File 1 = Separate File
				  		WScript.echo "Current OutputFile value: " & vbTab & ": " & OutputFile
			    		While(HashValue <= TotalHashValues)
								AddSignOnlyRule Array(Key.ID), Sign, HashValue, OutputFile
								AddVerifySignatureOnlyRule Array(Key.ID), VerifyOnly, guid
								WScript.sleep 1000
							    wscript.echo vbTab & "seeding folder monitor with file..."
							    Path = "c:\OpenPGP\pgpsignonly"
							    SeedCopy(Path)
	    						wscript.echo vbTab & "checking for event"
						'	    While (triggerflag = False)             'go into checking loop  'This does not work, it was hanging on this feature for this event rule only
						'	        Call CheckEventLog(guid)                
					'	        wscript.sleep 1000
						'	    Wend
						'**** We need to do a file comparison for the file located at c:\test.bin and c:\OpenPGP\pgpverifyonly\timestamp%test.bin****
					    		HashValue = HashValue + 1
					    		If HashValue <= TotalHashValues Then
							  		WScript.echo "Next HashValue:" & vbTab & ": " & HashValue
							   		WScript.echo "Next OutPut File Value: " & vbTab & ": " & Outputfile
							   	ElseIf HashValue = TotalHashValues Then
							   		WScript.Echo "All Hash Values completed"
							   	End if	 
							   	
						  WScript.Sleep 1000  	
					 	 Wend 'End Loop for HashValue
					 	
					 	 If HashValue = TotalHashValues Then
					 	 	WScript.Echo "All HashValues completed..."
					 	 End If
			
				
				     HashValue = 0 'Reset the HashValue back to zero for next key
			
					Next 'End Loop for OutputFile
			
			
				HashValue = 0
			
				WScript.Echo "Resetting Values: " & vbTab & "Hash Value: " & HashValue & " Outputfile Value: " & Outputfile
				If ASCIIArmored = 0 Then
							WScript.Echo "Continuing with next ASCII-Armored setting..."
					  ElseIf ASCIIArmored = 1 Then
							WScript.Echo "Continuing to next PGP Key..." 
							EncryptSignOnly = True
							
					  End If
			  Next 'Loop for ASCII-Armored
			  
			  If mainLoopCount = KeyCount Then
					WScript.Echo "All PGP Keys completed..." 
					'WScript.Echo "***Current Count is now: " &mainLoopCount&" ***"
			 		mainLoopCount = 0
						 	  	
			  End If
			  Path = Null
			  Loop While EncryptSignOnly <> True
			  

		HashValue = 0
		CompressionValue = 0
		mainLoopCount = 0
		
Next 'Key


'TO DO:
'
'function: create event rules w/ pgp action pair
'   param - pgp operation
'       crypt & decrypt
'       crypt+sign & decrypt+verify
'       sign & verify
'   param - pgp key (by id)
'   param - compression level (1-9, default 6)

'function: remove event rules

'function: create file
'i can be lazy about this and require "c:\test.bin" and bomb out if it doesn't exist.

'function: md5 or crc32
'get sum for starting file and decrypted, validates round trip file integrity.









wscript.echo "done."

'==============================================================================

Function AddEncryptRule(keyarray, operation, ASCIIArmored, CompressionValue)
    RemoveRule 4101, "PGP Encrypt"
    Set rules = site.EventRules(4101) 'MonitorFolder = 4101
    Set objParams = WScript.CreateObject("SFTPCOMInterface.CIFolderMonitorEventRuleParams")
        objParams.Name = "PGP Encrypt"
        objParams.Enabled = True
        objParams.Description = "pgp encrypt rule"
        objParams.Path = "c:\OpenPGP\pgpencrypt"
        objParams.IncludeSubfolders = True
        objParams.CheckHealth = True
        objParams.CheckHealthInterval = 10
    Set eventRule = rules.Add(rules.Count(), objParams)
    Set pgpaction = WScript.CreateObject("SFTPCOMInterface.CIPgpActionParams")
    	pgpaction.Operation = operation 'Encrypt
    	If ASCIIArmored = 0 Then
		   	pgpaction.ASCIIArmoredOutput = False
		   	WScript.Echo "Setting ASCII-Armored to False"
	    Else 
		   	pgpaction.ASCIIArmoredOutput = True
		   	WScript.Echo "Setting ASCII-Armored to True"
		End If
		pgpaction.CompressionLevel = CompressionValue
        pgpaction.KeyIDs = keyarray
        pgpaction.FilePath = "%FS.PATH%"
    Set objIfStatement = eventRule.AddIfStatement(eventRule.StatementsCount(), 5008, 1, "added", False)
    Set objCompoundCondition = objIfStatement.Condition
        objCompoundCondition.Operator = 1
        objCompoundCondition.Add 5005, 16, "*.pgp", true   'The last boolean parameter toggle the negative
    Set eventRule2 = objIfStatement.IfSection.Add(0, pgpaction)
    
    'move action - move pgpd file to decrypt folder
    Set copymove = WScript.CreateObject("SFTPCOMInterface.CIUploadActionParams")
        copymove.Protocol = -1 'localhost
        If ASCIIArmored = 0 Then
        	WScript.Sleep 1000
        	
		    'pgpaction.ASCIIArmoredOutput = False 'Need to remove
		    copymove.RemotePath = "c:\OpenPGP\testFiles\"&"Encrypt_"&"Compression_Value_"&CompressionValue&"_"&a(0)&"_"&"%EVENT.TIMESTAMP%_%FS.FILE_NAME%"
	    Else 
	    	WScript.Sleep 1000
	      	copymove.RemotePath = "c:\OpenPGP\testFiles\"&"Encrypt_"&"ASCII-Armored_"&"Compression_Value_"&CompressionValue&"_"&a(0)&"_"&"%EVENT.TIMESTAMP%_%FS.FILE_NAME%"
	    End If
        copymove.LocalPath = "%FS.PATH%"
        copymove.DeleteSourceFile = False
    'eventRule.AddActionStatement eventRule.StatementsCount(), copymove
    Set eventRule2 = objIfStatement.IfSection.Add(1, copymove)
    
     'move action - move pgpd file to decrypt folder
		    Set copymove = WScript.CreateObject("SFTPCOMInterface.CIUploadActionParams")
		        copymove.Protocol = -1 'localhost
		        WScript.Sleep 1000
		        copymove.RemotePath = "c:\OpenPGP\pgpdecrypt\"&"%EVENT.TIMESTAMP%_%FS.FILE_NAME%"
		        copymove.LocalPath = "%FS.PATH%"
		        copymove.DeleteSourceFile = True
	       'eventRule.AddActionStatement eventRule.StatementsCount(), copymove
		    Set eventRule2 = objIfStatement.IfSection.Add(2, copymove)
    
End Function    

'===========================================================================================================
'Encrypt and Sign Event Rule
Function AddEncryptAndSignRule(keyarray, operation, CompressionValue, HashValue, ASCIIArmored)
		    RemoveRule 4101, "PGP Encrypt And Sign"
		    
		    Set rules = site.EventRules(4101) 'MonitorFolder = 4101
		    Set objParams = WScript.CreateObject("SFTPCOMInterface.CIFolderMonitorEventRuleParams")
		        objParams.Name = "PGP Encrypt And Sign"
		        objParams.Enabled = True
		        objParams.Description = "pgp encrypt and sign rule"
		        objParams.Path = "c:\OpenPGP\pgpencryptandsign"
		        objParams.IncludeSubfolders = True
		        objParams.CheckHealth = True
		        objParams.CheckHealthInterval = 10
		    Set eventRule = rules.Add(rules.Count(), objParams)
		    Set pgpaction = WScript.CreateObject("SFTPCOMInterface.CIPgpActionParams")
		        pgpaction.Operation = operation 'Encrypt and sign
		        If ASCIIArmored = 0 Then
		        	pgpaction.ASCIIArmoredOutput = False
		        	WScript.Echo "Setting ASCII-Armored to False"
		        Else 
		        	pgpaction.ASCIIArmoredOutput = True
		        	WScript.Echo "Setting ASCII-Armored to True"
		        End if
		        pgpaction.CompressionLevel = CompressionValue
		        pgpaction.KeyIDs = keyarray
		        pgpaction.SignKeyID = Key.ID
		        pgpaction.PassPhrase = "testtest"
		        pgpaction.SigningHash = HashValue
		        Dim HashValueText
		        Select Case HashValue
		        	Case 0
		        		HashValueText = "MD5_"
		        		
		        	Case 1
		        		HashValueText = "SHA-1_"
		        		
		        	Case 2
		        		HashValueText = "RIPEMD-160_"
		        		
		        	Case 3
		        		HashValueText = "SHA-256_"
		        		
		        	Case 4
		        		HashValueText = "SHA-384_"
		        	Case 5
		        		HashValueText = "SHA-512_"
		        End Select
		        WScript.Echo HashValueText
		       ' Dim HashText
		       ' HashText = 0
		        pgpaction.FilePath = "%FS.PATH%"
			Set objIfStatement = eventRule.AddIfStatement(eventRule.StatementsCount(), 5008, 1, "added", False)
		    Set objCompoundCondition = objIfStatement.Condition
		        objCompoundCondition.Operator = 1
		        objCompoundCondition.Add 5005, 16, "*.pgp", true   'The last boolean parameter toggle the negative
		    Set eventRule2 = objIfStatement.IfSection.Add(0, pgpaction)
		    		
		   	
		    
		    Set copymove = WScript.CreateObject("SFTPCOMInterface.CIUploadActionParams")
		    	Dim countHash2
		        copymove.Protocol = -1 'localhost
		         If ASCIIArmored = 0 Then
		         	WScript.Sleep 1000
		         	countHash2 = HashValueText						        
		        	copymove.RemotePath = "c:\OpenPGP\testFiles\"&"EncryptAndSigned_"&"CompressionValue_"&CompressionValue&"_"&"HashValue_"&countHash2&"_"&a(0)&"_"&"Signed_ID_"&Key.ID&"_"&"%EVENT.TIMESTAMP%_%FS.FILE_NAME%"
		         Else 
		         	countHash = HashValueText
		         	WScript.Sleep 1000
		         	countHash2 = HashValueText	
		          	copymove.RemotePath = "c:\OpenPGP\testFiles\"&"EncryptAndSigned_"&"ASCII-Armored_"&"CompressionValue_"&CompressionValue&"_HashValue_"&countHash2&"_"&a(0)&"_"&"Signed_ID_"&Key.ID&"_"&"%EVENT.TIMESTAMP%_%FS.FILE_NAME%"
		         End If
		        
		        copymove.LocalPath = "%FS.PATH%"
		        copymove.DeleteSourceFile = False
		  ' eventRule.AddActionStatement eventRule.StatementsCount(), copymove
		    Set eventRule2 = objIfStatement.IfSection.Add(1, copymove)
		    
		    
		    'move action - move pgpd file to decrypt folder
		    Set copymove = WScript.CreateObject("SFTPCOMInterface.CIUploadActionParams")
		        copymove.Protocol = -1 'localhost
		        WScript.Sleep 1000
		        copymove.RemotePath = "c:\OpenPGP\pgpdecryptandverify\"&"%EVENT.TIMESTAMP%_%FS.FILE_NAME%"
		        copymove.LocalPath = "%FS.PATH%"
		        copymove.DeleteSourceFile = True
	       'eventRule.AddActionStatement eventRule.StatementsCount(), copymove
		    Set eventRule2 = objIfStatement.IfSection.Add(2, copymove)
		    HashText = Null
End Function    


'=============================================================================================================


'Sign Only Event Rule
Function AddSignOnlyRule(keyarray, operation, HashValue, OutputFile)
    RemoveRule 4101, "PGP Sign Only"
    Set rules = site.EventRules(4101) 'MonitorFolder = 4101
    Set objParams = WScript.CreateObject("SFTPCOMInterface.CIFolderMonitorEventRuleParams")
        objParams.Name = "PGP Sign Only"
        objParams.Enabled = True
        objParams.Description = "pgp Sign Only rule"
        objParams.Path = "c:\OpenPGP\pgpsignonly"
        objParams.IncludeSubfolders = True
        objParams.CheckHealth = True
        objParams.CheckHealthInterval = 10
    Set eventRule = rules.Add(rules.Count(), objParams)
    Set pgpaction = WScript.CreateObject("SFTPCOMInterface.CIPgpActionParams")
        pgpaction.Operation = operation 'Sign Only
        If ASCIIArmored = 0 Then
		   	pgpaction.ASCIIArmoredOutput = False
		   	WScript.Echo "Setting ASCII-Armored to False"
		Else 
		   	pgpaction.ASCIIArmoredOutput = True
		   	WScript.Echo "Setting ASCII-Armored to True"
		End If 
		Select Case HashValue
		    	Case 0
		       		HashValueText = "MD5_"
		      		
		       	Case 1
		       		HashValueText = "SHA-1_"
		       		
		       	Case 2
		       		HashValueText = "RIPEMD-160_"
		       		
		       	Case 3
		       		HashValueText = "SHA-256_"
		       		
		       	Case 4
		       		HashValueText = "SHA-384_"
		       	Case 5
		       		HashValueText = "SHA-512_"
		        End Select
		WScript.Echo HashValueText
		'pgpaction.KeyIDs = keyarray
        pgpaction.SignatureInSeparateFile = OutputFile
        pgpaction.SignKeyID = Key.ID
        pgpaction.SigningHash = HashValue
        pgpaction.FilePath = "%FS.PATH%"
        pgpaction.PassPhrase = "testtest"
			
    Set objIfStatement = eventRule.AddIfStatement(eventRule.StatementsCount(), 5008, 1, "added", False)
    Set objCompoundCondition = objIfStatement.Condition
        objCompoundCondition.Operator = 1
        objCompoundCondition.Add 5005, 16, Array("*.pgp","*.sig", "*.asc"), True   'The last boolean parameter toggle the negative
    Set eventRule2 = objIfStatement.IfSection.Add(0, pgpaction)
    
     Set copymove = WScript.CreateObject("SFTPCOMInterface.CIUploadActionParams")
		        copymove.Protocol = -1 'localhost
		        Dim countHash3
		         If ASCIIArmored = 0 And OutputFile = 0 Then
		         	countHash3 = HashValueText
		         	WScript.Sleep 1000
		         	copymove.RemotePath = "c:\OpenPGP\testFiles\"&"SignOnly_"&"TargetFile_"&"HashValue_"&countHash3&"_"&a(0)&"_"&"Signed_ID_"&Key.ID&"_"&"%EVENT.TIMESTAMP%_%FS.FILE_NAME%"
		         ElseIf ASCIIArmored = 0 And OutputFile = 1 Then
		         WScript.Sleep 1000
		         countHash3 = HashValueText
		         	copymove.RemotePath = "c:\OpenPGP\testFiles\"&"SignOnly_"&"SeparateFile_"&"HashValue_"&countHash3&"_"&a(0)&"_"&"Signed_ID_"&Key.ID&"_"&"%EVENT.TIMESTAMP%_%FS.FILE_NAME%"
		        '	pgpaction.ASCIIArmoredOutput = False 'I'm not sure why this is there, but it needs to be removed 3/21/14 - 8:31 AM
		        	'If OutputFile = 0 Then 'If Output set to TargetFile 			        		
		         	         'ElseIf ASCIIArmored = 1 Then
		         ElseIf ASCIIArmored = 1 And OutputFile = 0 Then
		         WScript.Sleep 1000
		         countHash3 = HashValueText
		         	copymove.RemotePath = "c:\OpenPGP\testFiles\"&"SignOnly_"&"ASCII-Armored_"&"TargetFile_"&"HashValue_"&countHash3&"_"&a(0)&"_"&"Signed_ID_"&Key.ID&"_"&"%EVENT.TIMESTAMP%_%FS.FILE_NAME%"
		         ElseIf ASCIIArmored = 1 And OutputFile = 1 Then
		         WScript.Sleep 1000
		         countHash3 = HashValueText
		         	'If OutputFile = 0 Then 'If Output Set to TargetFile          	
		          	copymove.RemotePath = "c:\OpenPGP\testFiles\"&"SignOnly_"&"ASCII-Armored_"&"SeparateFile_"&"HashValue_"&countHash3&"_"&a(0)&"_"&"Signed_ID_"&Key.ID&"_"&"%EVENT.TIMESTAMP%_%FS.FILE_NAME%"
		          	'End If
		         End If
		        
		        copymove.LocalPath = "%FS.PATH%"
		        copymove.DeleteSourceFile = False
		  ' eventRule.AddActionStatement eventRule.StatementsCount(), copymove
		    Set eventRule2 = objIfStatement.IfSection.Add(1, copymove)
    
    'move action - move pgpd file to decrypt folder
    Set copymove = WScript.CreateObject("SFTPCOMInterface.CIUploadActionParams")
        copymove.Protocol = -1 'localhost
        WScript.Sleep 1000
        copymove.RemotePath = "c:\OpenPGP\pgpdecryptverifyonly\"&"%EVENT.TIMESTAMP%_%FS.FILE_NAME%"
        copymove.LocalPath = "%FS.PATH%"
        copymove.DeleteSourceFile = True
 '   eventRule.AddActionStatement eventRule.StatementsCount(), copymove
  Set eventRule2 = objIfStatement.IfSection.Add(2, copymove)
    
      If OutputFile = 1 Then  'When Output file is configured for separate, the event rule leaves the file behind, this additional statement will move it to the Delete files path
        Set copymove = WScript.CreateObject("SFTPCOMInterface.CIUploadActionParams")
        copymove.Protocol = -1 'localhost
        WScript.Sleep 1000
        copymove.RemotePath = "c:\OpenPGP\DeleteFiles\"&"%EVENT.TIMESTAMP%_%FS.FILE_NAME%"
        copymove.LocalPath = "c:\OpenPGP\pgpsignonly\test.bin"
        copymove.DeleteSourceFile = True
   		Set eventRule2 = objIfStatement.IfSection.Add(3, copymove)
   	  End If
    HashText = Null
    
End Function    








'=============================================================================================================


Function AddDecryptRule(keyarray, operation, Message)
    RemoveRule 4101, "PGP Decrypt"
    Set rules = site.EventRules(4101) 'MonitorFolder = 4101
    Set objParams = WScript.CreateObject("SFTPCOMInterface.CIFolderMonitorEventRuleParams")
        objParams.Name = "PGP Decrypt"
        objParams.Enabled = True
        objParams.Description = "pgp decrypt rule"
        objParams.Path = "c:\OpenPGP\pgpdecrypt"
        objParams.IncludeSubfolders = True
        objParams.CheckHealth = True
        objParams.CheckHealthInterval = 10
    Set eventRule = rules.Add(rules.Count(), objParams)
    Set pgpaction = WScript.CreateObject("SFTPCOMInterface.CIPgpActionParams")
        'pgpaction.ASCIIArmoredOutput = False
        'pgpaction.CompressionLevel = CompressionLevel6
        pgpaction.KeyIDs = keyarray
        pgpaction.Operation = operation
        pgpaction.PassPhrase = "testtest"
        pgpaction.FilePath = "%FS.PATH%"
        
    'eventRule.AddActionStatement eventRule.StatementsCount(), pgpaction
    Set objIfStatement = eventRule.AddIfStatement(eventRule.StatementsCount(), 5008, 1, "added", False)
    Set objCompoundCondition = objIfStatement.Condition
        objCompoundCondition.Operator = 1
        objCompoundCondition.Add 5005, 16, Array("*.pgp", "*.asc", "*.sig"), False   'The last boolean parameter toggle the negative
    Set eventRule2 = objIfStatement.IfSection.Add(0, pgpaction)	
    
    'write to WEL
    Set eventaction = WScript.CreateObject("SFTPCOMInterface.CIWindowsEventLogActionParams")
        eventaction.Description = Message
        eventaction.EventID = 2
        eventaction.type = EventInformation
    eventRule.AddActionStatement eventRule.StatementsCount(), eventaction
End Function    


'=============================================================================================================
Function AddSDADecryptRule(keyarray, operation, Message)
    RemoveRule 4101, "PGP SDA Decrypt"
    Set rules = site.EventRules(4101) 'MonitorFolder = 4101
    Set objParams = WScript.CreateObject("SFTPCOMInterface.CIFolderMonitorEventRuleParams")
        objParams.Name = "PGP SDA Decrypt"
        objParams.Enabled = True
        objParams.Description = "pgp SDA decrypt rule"
        objParams.Path = "c:\OpenPGP\pgpencrypt"
        objParams.IncludeSubfolders = True
        objParams.CheckHealth = True
        objParams.CheckHealthInterval = 10
    Set eventRule = rules.Add(rules.Count(), objParams)
    Set pgpaction = WScript.CreateObject("SFTPCOMInterface.CIPgpActionParams")
        pgpaction.SDAPassword = "testtest"
        pgpaction.Operation = operation
        pgpaction.FilePath = "%FS.PATH%"
   'eventRule.AddActionStatement eventRule.StatementsCount(), pgpaction
    Set objIfStatement = eventRule.AddIfStatement(eventRule.StatementsCount(), 5008, 1, "added", False)
    Set objCompoundCondition = objIfStatement.Condition
        objCompoundCondition.Operator = 1
        objCompoundCondition.Add 5005, 16, "*.pgp, *.exe", true   'The last boolean parameter toggle the negative
    Set eventRule2 = objIfStatement.IfSection.Add(0, pgpaction)    
       
        'move action - move pgpd file to decrypt folder
    Set copymove = WScript.CreateObject("SFTPCOMInterface.CIUploadActionParams")
        copymove.Protocol = -1 'localhost
        copymove.RemotePath = "C:\OpenPGP\SDApgpencrypted\"&"SDADecrypt"&a(0)&"%EVENT.TIMESTAMP%_%FS.FILE_NAME%"
        copymove.LocalPath = "%FS.PATH%"
        copymove.DeleteSourceFile = True
    'eventRule.AddActionStatement eventRule.StatementsCount(), copymove
    Set eventRule2 = objIfStatement.IfSection.Add(1, copymove)
    
    
   
    
    'write to WEL
    Set eventaction = WScript.CreateObject("SFTPCOMInterface.CIWindowsEventLogActionParams")
        eventaction.Description = Message
        eventaction.EventID = 2
        eventaction.type = EventInformation
    eventRule.AddActionStatement eventRule.StatementsCount(), eventaction
End Function



'=============================================================================================================


'=============================================================================================================
'Decrypt & Verify Signature


Function AddDecryptAndVerifyRule(keyarray, operation, Message)
	RemoveRule 4101, "PGP Decrypt And Verify Signature"
    Set rules = site.EventRules(4101) 'MonitorFolder = 4101
    Set objParams = WScript.CreateObject("SFTPCOMInterface.CIFolderMonitorEventRuleParams")
        objParams.Name = "PGP Decrypt And Verify Signature"
        objParams.Enabled = True
        objParams.Description = "pgp decrypt and verify signature rule"
        objParams.Path = "c:\OpenPGP\pgpdecryptandverify"
        objParams.IncludeSubfolders = True
        objParams.CheckHealth = True
        objParams.CheckHealthInterval = 10
    Set eventRule = rules.Add(rules.Count(), objParams)
    Set pgpaction = WScript.CreateObject("SFTPCOMInterface.CIPgpActionParams")
        pgpaction.Operation = operation
        pgpaction.KeyIDs = keyarray
        pgpaction.SignKeyID = Key.ID
        pgpaction.PassPhrase = "testtest"
        pgpaction.FilePath = "%FS.PATH%"
              
'   	eventRule.AddActionStatement eventRule.StatementsCount(), pgpaction 'this creates the PGP action
	    Set objIfStatement = eventRule.AddIfStatement(eventRule.StatementsCount(), 5008, 1, "added", False)
	Set objCompoundCondition = objIfStatement.Condition
        objCompoundCondition.Operator = 1
        objCompoundCondition.Add 5005, 16, Array("*.pgp","*.asc", "*.sig"), False   'The last boolean parameter toggle the negative
    Set eventRule2 = objIfStatement.IfSection.Add(0, pgpaction)	
    
    'write to WEL
    Set eventaction = WScript.CreateObject("SFTPCOMInterface.CIWindowsEventLogActionParams")
        eventaction.Description = Message
        eventaction.EventID = 2
        eventaction.type = EventInformation
    eventRule.AddActionStatement eventRule.StatementsCount(), eventaction
End Function    

'=============================================================================================================

'=============================================================================================================
'Verify Signature Only

Function AddVerifySignatureOnlyRule(keyarray, operation, Message)
    RemoveRule 4101, "PGP Verify Signature Only"
    Set rules = site.EventRules(4101) 'MonitorFolder = 4101
    Set objParams = WScript.CreateObject("SFTPCOMInterface.CIFolderMonitorEventRuleParams")
        objParams.Name = "PGP Verify Signature Only"
        objParams.Enabled = True
        objParams.Description = "pgp verify signature only rule"
        objParams.Path = "c:\OpenPGP\pgpdecryptverifyonly"
        objParams.IncludeSubfolders = True
        objParams.CheckHealth = True
        objParams.CheckHealthInterval = 10
    Set eventRule = rules.Add(rules.Count(), objParams)
    Set pgpaction = WScript.CreateObject("SFTPCOMInterface.CIPgpActionParams")      
        pgpaction.SignKeyID = Key.ID
        pgpaction.Operation = operation
        pgpaction.FilePath = "%FS.PATH%"
        pgpaction.PassPhrase = "testtest"
    'eventRule.AddActionStatement eventRule.StatementsCount(), pgpaction  'this commits the event rule
    Set objIfStatement = eventRule.AddIfStatement(eventRule.StatementsCount(), 5008, 1, "added", False)
    Set objCompoundCondition = objIfStatement.Condition
        objCompoundCondition.Operator = 1
        objCompoundCondition.Add 5005, 16, Array("*.pgp","*.asc","*.sig"), false   'The last boolean parameter toggle the negative
    Set eventRule2 = objIfStatement.IfSection.Add(0, pgpaction)
    'write to WEL
    Set eventaction = WScript.CreateObject("SFTPCOMInterface.CIWindowsEventLogActionParams")
        eventaction.Description = Message
        eventaction.EventID = 2
        eventaction.type = EventInformation
    eventRule.AddActionStatement eventRule.StatementsCount(), eventaction
End Function    


'=============================================================================================================


Function RemoveRule(RuleType, RuleName)
    'iterate through all rules of a given type and delete by name
    'wscript.echo "checking rule:" & vbTab & RuleName
    Set rules = site.EventRules(RuleType)
    'wscript.echo "rule count:" & vbTab & rules.Count
    For i = 0 To rules.Count -1 
        Set params = rules.Item(i).GetParams
            If params.Name = RuleName then
                'wscript.echo "deleting rule" & vbTab & params.Name
                rules.Delete(i)
                Exit Function
            End If
    Next 'i
End Function       


Function ExportKeys
    'export all pgp keys to asc files
    Set objFSO = CreateObject("Scripting.FileSystemObject")
        If Not objFSO.FolderExists("ExportedKeys") Then
            Set objFolder = objFSO.CreateFolder("ExportedKeys")
        End If
	
    For Each Key In SFTPServer.AvailablePGPKeys
        a=Split(Key.Name," <")
        b=Split(a(0),"PGPKeyType_")
        SFTPServer.ExportPGPKey Key.ID, True, "ExportedKeys\" & b(1) & ".asc"
    Next
End Function


Function RemovePGPKeys()
    'clear all existing pgp keys from the server
    For Each Key In SFTPServer.AvailablePGPKeys
        a=Split(Key.Name," <")
        wscript.echo vbtab & Key.ID & vbTab & a(0)
        SFTPServer.RemovePGPKey(Key.ID)
    Next
End Function


Function CreatePGPKeys
    'create each pgp key type
    wscript.echo "Creating PGP keys..."
    expdate = CDate("October 1, 2050")
    KeyCount=0
    For KeyType = Lbound(PGPKeyTypes) to Ubound(PGPKeyTypes)
        For KeyCipher = lbound(PGPKeyCiphers) to ubound(PGPKeyCiphers)
        	
            For KeySize = lbound(PGPKeySizes) to ubound(PGPKeySizes)
            	
                Fullname = PGPKeyTypes(KeyType) & PGPKeyCiphers(KeyCipher) & PGPKeySizes(KeySize)
                Email = PGPKeyTypes(KeyType) & "@" & PGPKeyCiphers(KeyCipher) & "." & PGPKeySizes(KeySize)
                wscript.echo "Creating Key:" & vbTab & Fullname
                KeyCount = KeyCount +1
                SFTPServer.CreatePGPKey Fullname, Email, expdate, KeyType, KeyCipher, PGPKeySizes(KeySize), "testtest"
                wscript.sleep .5  ' avoid race conditions, give the server a second to breathe
            Next ' KeySize
        Next ' KeyCipher
        
    Next ' KeyType
    wscript.sleep 1
    SFTPServer.RefreshSettings
End Function


Function CheckForEvent(guid)
    triggerflag = False
    While (triggerflag = False)
        'wscript.echo "checking for event: " & vbTab & guid
        CheckEventLog guid
        wscript.sleep 1000
    Wend
End Function


Function CheckEventLog(guid)
    'checks the windows application log for a specific guid
    strComputer = "."
    Set objWMIService = GetObject("winmgmts:" _
        & "{impersonationLevel=impersonate}!\\" _
        & strComputer & "\root\cimv2")
    Set colLoggedEvents = objWMIService.ExecQuery _
        ("Select * from Win32_NTLogEvent " _
            & "Where Logfile = 'Application'")
    For Each objEvent in colLoggedEvents
        If ((objEvent.Message = guid) and (objEvent.SourceName = "EFT Server Enterprise")) Then
            'we can push clientdll return code through objEvent.EventCode
            triggerflag = True
            'wscript.echo vbTab & "event found"
        End If 
    Next 'objEvent
End Function


Function ClearEventLog
    'clears the windows application log
    strComputer = "."
    Set objWMIService = GetObject("winmgmts:" _
        & "{impersonationLevel=impersonate,(Backup)}!\\" & _
        strComputer & "\root\cimv2")
    Set colLogFiles = objWMIService.ExecQuery _
        ("Select * from Win32_NTEventLogFile " _
        & "Where LogFileName='Application'")
    For Each objLogfile in colLogFiles
        objLogFile.ClearEventLog()
    Next 'objLogfile
End Function


Function CreateGuid()
    'create a guid and strip off the curly braces/brackets
    CreateGuid = Mid(CreateObject("Scriptlet.TypeLib").Guid, 2, 36)
End Function


Function FolderPrep
    'we use hard coded directories for the event rules
    'this sanitizes the content by deleting any existing
    'copies and creating new ones
    Folders = Array("c:\OpenPGP", "c:\OpenPGP\pgpencrypt","c:\OpenPGP\pgpdecrypt","c:\OpenPGP\SDApgpencrypted", "c:\OpenPGP\testFiles","c:\OpenPGP\pgpencryptandsign","c:\OpenPGP\pgpdecryptandverify", "c:\OpenPGP\pgpsignonly", "c:\OpenPGP\pgpdecryptverifyonly", "c:\OpenPGP\DeleteFiles")
    Set objFSO = CreateObject("Scripting.FileSystemObject")
    For Each Folder In Folders
        If objFSO.FolderExists(Folder) Then
            'wscript.echo "removing folder:" & vbTab & Folder
            objFSO.DeleteFolder(Folder)
            wscript.sleep 1000
        End If
        'wscript.echo "creating folder:" & vbTab & Folder
        objFSO.CreateFolder(Folder)
    Next 'Folder
End Function


Function FileCheck
    If (CheckFile("c:\test.bin") = False) Then
        wscript.echo "file not found:" & vbTab & "c:\test.bin"
        wscript.echo "please create source file, exiting script."
        wscript.quit
    end if
End Function


Function CheckFile(Filepath)
    Call log("checking for file:" & vbTab & Filepath)
    Checkfile = False
    Set fso = CreateObject("Scripting.FileSystemObject")
    If (fso.FileExists(Filepath)) Then
        CheckFile = True
    End If
End function


Function SeedCopy(Path)
    Set objFSO = CreateObject("Scripting.FileSystemObject")
    objFSO.CopyFile "c:\test.bin", Path&"\test.bin"
End Function


Function Log(Message)
    If (verbose = True) Then
        wscript.echo Message
        logfile="c:\CopyMove.log"
        Set objFSO = CreateObject("Scripting.FileSystemObject")
        Set objFile = objFSO.OpenTextFile(logfile,8,True)
        objFile.Write Message & vbCrLf
        objFile.Close        
    End If
End Function


