﻿$serverIp = "localhost"
$serverPort = 1100

$EFTServer = New-Object -COM "SFTPCOMInterface.CIServer"
$EFTServer.ConnectEX($serverIP, $serverPort, 1, "","")

$EFTAdminPermission = New-Object -COM "SFTPCOMInterface.CIAdminPermission"

Write-Host "------------------------------------------------------------------------------------------------------"
Write-Host "- This script creates EFT Server Admins (full control) with the username: " -NoNewline; Write-Host "admin-#" -ForegroundColor Green -NoNewline; Write-Host " and password "  -NoNewline; Write-Host "nimda" -ForegroundColor Green -NoNewline; Write-Host " -"
Write-Host "------------------------------------------------------------------------------------------------------"
[uint16]$createAdmins = Read-Host -Prompt "Enter the number of Server Admins to create"

Try
{
for($j = 1; $j -le $createAdmins; $j++)
 {
$adminUser = $null
$adminUser = $EFTServer.CreateAdmin( "admin-$j", "nimda", 0, $false)

$EFTAdminPermission.Permission = 0 #ServerAdmin
$adminUser.AddPermission($EFTAdminPermission)

$EFTAdminPermission.Permission = 5 #COMManagement
$adminUser.AddPermission($EFTAdminPermission)

$EFTAdminPermission.Permission = 6 #ReportManagement
$adminUser.AddPermission($EFTAdminPermission)

$EFTAdminPermission.Permission = 8 #ManagePersonalData EFT v8+
$adminUser.AddPermission($EFTAdminPermission)

Write-Host "Created: " $adminUser.Login
}
 
}

Catch
{
Write-Host "ERROR!"
$EFTServer.Close() | out-null
Remove-Variable * -ErrorAction SilentlyContinue
Sleep 3
}

Finally
{
Write-Host "Done!"
$EFTServer.Close() | out-null
Remove-Variable * -ErrorAction SilentlyContinue
Sleep 3
}