﻿$serverIp = "localhost"
$serverPort = 1100

$EFTServer = New-Object -COM "SFTPCOMInterface.CIServer"
$EFTServer.ConnectEX($serverIP, $serverPort, 1, "","")
$siteCount = $EFTServer.Sites().Count()
$ErrorActionPreference = 'Stop'
$siteID = $null
$siteName = $null

$rule = "Folder Monitor"
$EFTMonitorRule = New-Object -COM "SFTPCOMInterface.CIFolderMonitorEventRuleParams"
$EFTMonitorRule.Name = "Monitor-#"
$EFTMonitorRule.Enabled = $true
$EFTMonitorRule.Description = "This is a test event rule"
$EFTMonitorRule.Path = "C:\EFTMonitoredFolder"

$EFTActionWEL = New-Object -COM "SFTPCOMInterface.CIWindowsEventLogActionParams"
$EFTActionWEL.Description = "Test"
$EFTActionWEL.EventID = 2
$EFTActionWEL.Type = 0

for($k = 0; $k -lt $EFTServer.AvailableEvents.Count; $k++) #Loop to find the event rule type from list of all event rules
{
if($EFTServer.AvailableEvents[$k].Name -eq $rule)
  { $rule = $EFTServer.AvailableEvents[$k] }
}

Write-Host "------------------------------------------------------"
Write-Host "- This script creates dummy monitor rules: " -NoNewline; Write-Host "monitor-#" -ForegroundColor Green -NoNewline; Write-Host " -"
Write-Host "------------------------------------------------------" 
Write-Host ""
[string]$siteName = Read-Host -Prompt "Enter the name of the Site to configure or type --list to see availible sites"

while($siteName.Equals("--list"))
{
Write-Host ""
Write-Host "Sites"
Write-Host "-----"
for($j = 0; $j -lt $siteCount; $j++) #for loop to list availible sites
 {
Write-Host $EFTServer.Sites().Item($j).Name
 }
 Write-Host ""
[string]$siteName = Read-Host -Prompt "Enter the name of the Site to configure or type --list to see availible sites"
}

for($j = 0; $j -lt $siteCount; $j++) #for loop to find siteID
 {
  if ($EFTServer.Sites().Item($j).Name -eq $siteName)
  {
  $siteID = $EFTServer.Sites().Item($j).Id
  $siteName = $EFTServer.Sites().Item($j).Name
  }
 }

 if ($siteID -le 0)
  {
  Write-Host "Could no find site!"
  exit
  }

Write-Host ""
Write-Host $siteName -ForegroundColor Green -NoNewline 
[string]$howMany = Read-Host -Prompt " - How many to create?"

Try
{

if (!(Test-Path "C:\EFTMonitoredFolder"))
{
New-Item -itemType Directory -Path C:\ -Name "EFTMonitoredFolder" | Out-Null
}

for($j = 1; $j -le $howMany; $j++)
 {
  $x = $null
  $EFTMonitorRule.Name = "Monitor-$j"
  $x = $EFTServer.Sites().SiteByID($SiteID).EventRules($rule.type).Add(0,$EFTMonitorRule)
  #$x.AddIfStatement(0,5008,1,"renamed",$false) | Out-Null  #
  #$x.Statement(0).IfSection().AddActionStatement(0,$EFTActionWEL) #

} 
}

Catch
{
Write-Host "Error!" -NoNewline -ForegroundColor Red; Write-Host " - Make sure the site does not already have any timer rules named: " -NoNewline; Write-Host "monitor-#" -Foregroundcolor Green
Write-Output "Ran into an issue: $PSItem"
$EFTServer.Close() | out-null
Remove-Variable * -ErrorAction SilentlyContinue
exit
}

Write-Host "Done!"
Sleep 2
$EFTServer.Close() | out-null
Remove-Variable * -ErrorAction SilentlyContinue
