﻿$serverIp = "localhost"
$serverPort = 1100

$EFTServer = New-Object -COM "SFTPCOMInterface.CIServer"
$EFTServer.ConnectEX($serverIP, $serverPort, 1, "","")
$siteCount = $EFTServer.Sites().Count()
$vFolder = "Virtual/Virtual-"

$ErrorActionPreference = 'Stop'
$siteID = $null
$siteName = $null

Write-Host "------------------------------------------------------------------------------------------"
Write-Host "- This script creates virtual folders pointing to the site root named " -NoNewline; Write-Host "Virtual/Virtual-#/" -ForegroundColor Green -NoNewline; Write-Host " -"
Write-Host "------------------------------------------------------------------------------------------" 
Write-Host ""
[string]$siteName = Read-Host -Prompt "Enter the name of the Site to configure or type --list to see availible sites"

while($siteName.Equals("--list"))
{
Write-Host ""
Write-Host "Sites"
Write-Host "-----"
for($j = 0; $j -lt $siteCount; $j++) #for loop to list availible sites
 {
Write-Host $EFTServer.Sites().Item($j).Name
 }
 Write-Host ""
[string]$siteName = Read-Host -Prompt "Enter the name of the Site to configure or type --list to see availible sites"
}

for($j = 0; $j -lt $siteCount; $j++) #for loop to find siteID
 {
  if ($EFTServer.Sites().Item($j).Name -eq $siteName)
  {
  $siteID = $EFTServer.Sites().Item($j).Id
  $siteName = $EFTServer.Sites().Item($j).Name
  $siteRoot = $EFTServer.Sites().SiteById($siteID).GetRootFolder()
  }
 }

 if ($siteID -le 0)
  {
  Write-Host "Could no find site!"
  exit
  }

Write-Host ""
Write-Host $siteName -ForegroundColor Green -NoNewline 
[string]$howMany = Read-Host -Prompt " - How many to create?"

Try
{
for($j = 1; $j -le $howMany; $j++)
 {
$EFTServer.Sites().SiteById($siteID).CreateVirtualFolder("$vFolder$j/","$siteRoot")
} 
}

Catch
{
Write-Host "Error!" -NoNewline -ForegroundColor Red; Write-Host " - Make sure the site does not already have any virtual folders named: " -NoNewline; Write-Host "Virtual-#" -Foregroundcolor Green
$EFTServer.Close() | out-null
Remove-Variable * -ErrorAction SilentlyContinue
exit
}
Write-Host "Done!"
Sleep 2
$EFTServer.Close() | out-null
Remove-Variable * -ErrorAction SilentlyContinue
